# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ....core.pydantic_utilities import pydantic_v1


class Tracking(pydantic_v1.BaseModel):
    os_version: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    The operating system version
    """

    ip: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    The IP address of the device
    """

    lat: typing.Optional[str] = pydantic_v1.Field(default=None)
    """
    The latitude of the device
    """

    long_: typing.Optional[str] = pydantic_v1.Field(alias="long", default=None)
    """
    The longitude of the device
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        populate_by_name = True
        extra = pydantic_v1.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
